#ifndef WIDGET_H
#define WIDGET_H

#include <QWidget>
#include <QVector>
#include <QCheckBox>
#include<QSerialPort>
#include"settingsdialog.h"

QT_BEGIN_NAMESPACE
namespace Ui { class Widget; }
QT_END_NAMESPACE

class Widget : public QWidget
{
    Q_OBJECT

public:
    Widget(QWidget *parent = nullptr);
    unsigned char getSwitch();
    void changeColor(int num, QColor couleur );
    void setLED(unsigned char val);
     void showStatusMessage(const QString &message);
    ~Widget();
     unsigned int hex2int(QByteArray data);
     char * int2hex(char * Buffer,unsigned int val);


private:
    Ui::Widget *ui;


public slots :
 void communicateUSB();
 void openSerialPort();
 void closeSerialPort();
 void updateLED();
 void handleError(QSerialPort::SerialPortError error);
 void handleSerialPortOpen();

private :
 SettingsDialog *m_settings = nullptr;
 QSerialPort *m_serial = nullptr;
 unsigned char valMem;
 QVector<QCheckBox*>* mCheckboxes;



};
#endif // WIDGET_H
