#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on janvier 2021

@author: Anthony Juton
"""

import serial as s
import tkinter

#Fenêtre de configuration du port série
fenetre_demande = tkinter.Tk()
fenetre_demande.title('Config IHM TeleTP')
texte = tkinter.Label(fenetre_demande,text = "Veuillez saisir le port (COM* pour Win, /dev/ttyACM* pour Linux) sur lequel la carte arduino est connectée :")
texte.pack()

ligne_saisie = tkinter.Entry(fenetre_demande)
ligne_saisie.pack()

texte2 = tkinter.Label(fenetre_demande,text = "Attention ! * est un chiffre ! Appuyez sur OK puis quittez la fenêtre.")
texte2.pack()

def callback():
    global val_port_serie
    val_port_serie = ligne_saisie.get()
    print(val_port_serie)

bouton = tkinter.Button(fenetre_demande, text = "OK", width = 10, command=callback)
bouton.pack()

fenetre_demande.mainloop()

#Ouverture du port série et lancement de la fenêtre principale
port_serie=s.Serial(port=val_port_serie, baudrate=115200,bytesize = 8,parity='N', stopbits=1, timeout=None,  write_timeout=None, xonxoff=False, rtscts=False, dsrdtr=False)
if port_serie.isOpen():
    #Mise en entrée des 8 bits de poids fort et en sortie des 8 bits de poids faible
    port_serie.write(str.encode('O00FF\n'))
    
    #création de la fenêtre avec ses leds et ses boutons.
    fenetre=tkinter.Tk()
    fenetre.title('Widget IHM TeleTP')
    espace_IHM = tkinter.Canvas(fenetre, width = 320, height = 240)
    espace_IHM.pack()
    ligne = []
    Led = []
    Bouton=[]
    val_bouton = []
    for i in range(0,8):
        print(i)
        Led.append(espace_IHM.create_oval(30+35*i,40,50+35*i,60,fill='grey'))
        Bouton.append(espace_IHM.create_rectangle(30+35*i,180,50+35*i,200,fill='grey'))
        val_bouton.append(0)
    legendeled = tkinter.Label(fenetre,text='LeD4 LeD5 LeD6 LeD7 LeD8 LeD9 LeD10 LeD11')
    legendeled.place(x = 160, y = 80, anchor = 'center')
    legendebp = tkinter.Label(fenetre,text='bpA0 bpA1 bpA2 bpA3 bpA4 bpA5 bpD2 bpD3')
    legendebp.place(x = 165, y = 160, anchor = 'center')
    
    #fonction exécutée lors du clic souris 
    def coordsSouris(event):
        print(event.x, event.y)
        if((event.y>=180) and (event.y<200)):
            for i in range(0,8) :
                if((event.x>(30+35*i)) and (event.x<(50+35*i))):
                    if(val_bouton[i]==0):
                        val_bouton[i]=1;
                        espace_IHM.itemconfigure(Bouton[i],fill='green')
                        if(i<4) : port_serie.write(str.encode('S000%d\n' % ((1<<i))))
                        else : port_serie.write(str.encode('S00%d0\n' % ((1<<(i-4)))))
                    else:
                        val_bouton[i]=0;
                        espace_IHM.itemconfigure(Bouton[i],fill='grey')
                        if(i<4) : port_serie.write(str.encode('R000%d\n' % ((1<<i))))
                        else : port_serie.write(str.encode('R00%d0\n' % ((1<<(i-4)))))

    #lien entre la fonction coordsSouris et l'événement clic bouton gauche    
    espace_IHM.bind("<Button-1>", coordsSouris)

    while True:#infinte loop
        if (port_serie.in_waiting>0):
            print('message arrive')
            ligne = port_serie.read_until()
            print(ligne)
            val_int = 0
            if(((ligne[0]>=0x30) and (ligne[0]<=0x39)) or ((ligne[0]>=0x41) and (ligne[0]<=0x46))) :
                if((ligne[0]>=0x30) and (ligne[0]<=0x39)) : val_int = (ligne[0]-0x30)*16
                else : val_int = (ligne[0]-0x37)*16
            if(((ligne[1]>=0x30) and (ligne[1]<=0x39)) or ((ligne[1]>=0x41) and (ligne[1]<=0x46))) :
                if((ligne[1]>=0x30) and (ligne[1]<=0x39)) : val_int += (ligne[1]-0x30)
                else : val_int += (ligne[1]-0x37)
            for i in range(0,8) :
                    if((val_int & (1<<i))!=0) : espace_IHM.itemconfigure(Led[i],fill='red')
                    else : espace_IHM.itemconfigure(Led[i],fill='grey')
           
        espace_IHM.update_idletasks()
        espace_IHM.update()

    
    
    








